# coding: utf-8

"""
    Bluefin API

    Bluefin API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from bluefin_pro_api_client.models.asset import Asset
from bluefin_pro_api_client.models.trading_fees import TradingFees
from typing import Optional, Set
from typing_extensions import Self

class Account(BaseModel):
    """
    Account
    """ # noqa: E501
    trading_fees: TradingFees = Field(alias="tradingFees")
    can_trade: StrictBool = Field(description="If the user can trade.", alias="canTrade")
    can_deposit: StrictBool = Field(description="If the current user can deposit to the account.", alias="canDeposit")
    can_withdraw: StrictBool = Field(description="If the current user can withdraw from the account.", alias="canWithdraw")
    total_effective_balance_e9: StrictStr = Field(description="Total effective balance in USD (e9 format).", alias="totalEffectiveBalanceE9")
    total_initial_margin_required_e9: StrictStr = Field(description="The sum of initial margin required across all cross positions (e9 format).", alias="totalInitialMarginRequiredE9")
    total_open_order_initial_margin_required_e9: StrictStr = Field(description="The sum of initial margin required across all open orders (e9 format).", alias="totalOpenOrderInitialMarginRequiredE9")
    initial_margin_available_e9: StrictStr = Field(description="The amount of margin available to open new positions and orders (e9 format).", alias="initialMarginAvailableE9")
    total_maint_margin_required_e9: StrictStr = Field(description="The sum of maintenance margin required across all cross positions (e9 format).", alias="totalMaintMarginRequiredE9")
    maint_margin_available_e9: StrictStr = Field(description="The amount of margin available before liquidation (e9 format).", alias="maintMarginAvailableE9")
    account_maint_margin_ratio_e9: StrictStr = Field(description="The ratio of the maintenance margin required to the account value (e9 format).", alias="accountMaintMarginRatioE9")
    account_leverage_e9: StrictStr = Field(description="The leverage of the account (e9 format).", alias="accountLeverageE9")
    total_unrealized_pnl_e9: StrictStr = Field(description="Total unrealized profit (e9 format).", alias="totalUnrealizedPnlE9")
    total_cross_unrealized_pnl_e9: StrictStr = Field(description="Unrealized profit of crossed positions (e9 format).", alias="totalCrossUnrealizedPnlE9")
    last_updated_at_utc_millis: StrictInt = Field(description="Last update time in milliseconds since Unix epoch.", alias="lastUpdatedAtUtcMillis")
    assets: List[Asset]
    __properties: ClassVar[List[str]] = ["tradingFees", "canTrade", "canDeposit", "canWithdraw", "totalEffectiveBalanceE9", "totalInitialMarginRequiredE9", "totalOpenOrderInitialMarginRequiredE9", "initialMarginAvailableE9", "totalMaintMarginRequiredE9", "maintMarginAvailableE9", "accountMaintMarginRatioE9", "accountLeverageE9", "totalUnrealizedPnlE9", "totalCrossUnrealizedPnlE9", "lastUpdatedAtUtcMillis", "assets"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Account from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of trading_fees
        if self.trading_fees:
            _dict['tradingFees'] = self.trading_fees.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in assets (list)
        _items = []
        if self.assets:
            for _item_assets in self.assets:
                if _item_assets:
                    _items.append(_item_assets.to_dict())
            _dict['assets'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Account from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "tradingFees": TradingFees.from_dict(obj["tradingFees"]) if obj.get("tradingFees") is not None else None,
            "canTrade": obj.get("canTrade"),
            "canDeposit": obj.get("canDeposit"),
            "canWithdraw": obj.get("canWithdraw"),
            "totalEffectiveBalanceE9": obj.get("totalEffectiveBalanceE9"),
            "totalInitialMarginRequiredE9": obj.get("totalInitialMarginRequiredE9"),
            "totalOpenOrderInitialMarginRequiredE9": obj.get("totalOpenOrderInitialMarginRequiredE9"),
            "initialMarginAvailableE9": obj.get("initialMarginAvailableE9"),
            "totalMaintMarginRequiredE9": obj.get("totalMaintMarginRequiredE9"),
            "maintMarginAvailableE9": obj.get("maintMarginAvailableE9"),
            "accountMaintMarginRatioE9": obj.get("accountMaintMarginRatioE9"),
            "accountLeverageE9": obj.get("accountLeverageE9"),
            "totalUnrealizedPnlE9": obj.get("totalUnrealizedPnlE9"),
            "totalCrossUnrealizedPnlE9": obj.get("totalCrossUnrealizedPnlE9"),
            "lastUpdatedAtUtcMillis": obj.get("lastUpdatedAtUtcMillis"),
            "assets": [Asset.from_dict(_item) for _item in obj["assets"]] if obj.get("assets") is not None else None
        })
        return _obj


