# coding: utf-8

"""
    Bluefin API

    Bluefin API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from typing import Optional, Set
from typing_extensions import Self

class AccountPositionLeverageUpdateRequestSignedFields(BaseModel):
    """
    AccountPositionLeverageUpdateRequestSignedFields
    """ # noqa: E501
    account_address: StrictStr = Field(description="The Account Address from which to update leverage", alias="accountAddress")
    market_address: StrictStr = Field(description="Market address of the positions for which to update the leverage", alias="marketAddress")
    leverage_e9: StrictStr = Field(description="The leverage to set for the account positions (Must be a number in base e9)", alias="leverageE9")
    salt: StrictStr = Field(description="The random generated SALT. Should always be a number")
    signed_at_utc_millis: StrictInt = Field(description="The timestamp in millis at which the request was signed", alias="signedAtUtcMillis")
    __properties: ClassVar[List[str]] = ["accountAddress", "marketAddress", "leverageE9", "salt", "signedAtUtcMillis"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of AccountPositionLeverageUpdateRequestSignedFields from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of AccountPositionLeverageUpdateRequestSignedFields from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "accountAddress": obj.get("accountAddress"),
            "marketAddress": obj.get("marketAddress"),
            "leverageE9": obj.get("leverageE9"),
            "salt": obj.get("salt"),
            "signedAtUtcMillis": obj.get("signedAtUtcMillis")
        })
        return _obj


