# coding: utf-8

"""
    Bluefin API

    Bluefin API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from typing import Optional, Set
from typing_extensions import Self

class Asset2(BaseModel):
    """
    Details about an asset in the account.
    """ # noqa: E501
    bank_address: StrictStr = Field(description="The address of the bank.", alias="bankAddress")
    quantity_e9: StrictStr = Field(description="The quantity of the asset.", alias="quantityE9")
    effective_balance_e9: StrictStr = Field(description="The effective balance of the asset.", alias="effectiveBalanceE9")
    max_withdraw_quantity_e9: StrictStr = Field(description="The maximum quantity that can be withdrawn.", alias="maxWithdrawQuantityE9")
    updated_at_utc_millis: StrictInt = Field(description="The timestamp of the last update in milliseconds.", alias="updatedAtUtcMillis")
    __properties: ClassVar[List[str]] = ["bankAddress", "quantityE9", "effectiveBalanceE9", "maxWithdrawQuantityE9", "updatedAtUtcMillis"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Asset2 from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Asset2 from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "bankAddress": obj.get("bankAddress"),
            "quantityE9": obj.get("quantityE9"),
            "effectiveBalanceE9": obj.get("effectiveBalanceE9"),
            "maxWithdrawQuantityE9": obj.get("maxWithdrawQuantityE9"),
            "updatedAtUtcMillis": obj.get("updatedAtUtcMillis")
        })
        return _obj


