# coding: utf-8

"""
    Bluefin API

    Bluefin API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List
from bluefin_pro_api_client.models.asset1 import Asset1
from bluefin_pro_api_client.models.market import Market
from typing import Optional, Set
from typing_extensions import Self

class ExchangeInfoResponse(BaseModel):
    """
    ExchangeInfoResponse
    """ # noqa: E501
    assets: List[Asset1] = Field(description="List of assets available on the exchange.")
    markets: List[Market] = Field(description="List of markets available on the exchange.")
    trading_gas_fee_e9: StrictStr = Field(description="Current gas fee set for subsidized trades (e9 format)", alias="tradingGasFeeE9")
    server_time_at_utc_millis: StrictInt = Field(description="Server time in milliseconds.", alias="serverTimeAtUtcMillis")
    timezone: StrictStr = Field(description="Timezone of the exchange.")
    __properties: ClassVar[List[str]] = ["assets", "markets", "tradingGasFeeE9", "serverTimeAtUtcMillis", "timezone"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ExchangeInfoResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in assets (list)
        _items = []
        if self.assets:
            for _item_assets in self.assets:
                if _item_assets:
                    _items.append(_item_assets.to_dict())
            _dict['assets'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in markets (list)
        _items = []
        if self.markets:
            for _item_markets in self.markets:
                if _item_markets:
                    _items.append(_item_markets.to_dict())
            _dict['markets'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ExchangeInfoResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "assets": [Asset1.from_dict(_item) for _item in obj["assets"]] if obj.get("assets") is not None else None,
            "markets": [Market.from_dict(_item) for _item in obj["markets"]] if obj.get("markets") is not None else None,
            "tradingGasFeeE9": obj.get("tradingGasFeeE9"),
            "serverTimeAtUtcMillis": obj.get("serverTimeAtUtcMillis"),
            "timezone": obj.get("timezone")
        })
        return _obj


