# coding: utf-8

"""
    Bluefin API

    Bluefin API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field
from typing import Any, ClassVar, Dict, List
from bluefin_pro_api_client.models.market_data_stream import MarketDataStream
from bluefin_pro_api_client.models.subscription_type import SubscriptionType
from typing import Optional, Set
from typing_extensions import Self

class MarketSubscriptionMessage(BaseModel):
    """
    Subscription message for market data streams.
    """ # noqa: E501
    method: SubscriptionType
    data_streams: List[MarketDataStream] = Field(description="List of market data streams to subscribe or unsubscribe from.", alias="dataStreams")
    __properties: ClassVar[List[str]] = ["method", "dataStreams"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MarketSubscriptionMessage from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of each item in data_streams (list)
        _items = []
        if self.data_streams:
            for _item_data_streams in self.data_streams:
                if _item_data_streams:
                    _items.append(_item_data_streams.to_dict())
            _dict['dataStreams'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MarketSubscriptionMessage from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "method": obj.get("method"),
            "dataStreams": [MarketDataStream.from_dict(_item) for _item in obj["dataStreams"]] if obj.get("dataStreams") is not None else None
        })
        return _obj


