# coding: utf-8

"""
    Bluefin API

    Bluefin API

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from bluefin_pro_api_client.models.order_cancel_reason import OrderCancelReason
from bluefin_pro_api_client.models.order_cancellation_failure_reason import OrderCancellationFailureReason
from typing import Optional, Set
from typing_extensions import Self

class OrderCancellationUpdate(BaseModel):
    """
    Details of an order cancellation.
    """ # noqa: E501
    order_hash: StrictStr = Field(description="The unique hash of the order.", alias="orderHash")
    client_order_id: Optional[StrictStr] = Field(default=None, description="The client-provided order ID.", alias="clientOrderId")
    market_address: StrictStr = Field(description="The address of the market.", alias="marketAddress")
    account_address: StrictStr = Field(description="The address of the account.", alias="accountAddress")
    created_at_utc_millis: StrictInt = Field(description="The timestamp of the order creation in milliseconds.", alias="createdAtUtcMillis")
    cancellation_reason: OrderCancelReason = Field(alias="cancellationReason")
    failure_to_cancel_reason: Optional[OrderCancellationFailureReason] = Field(default=None, alias="failureToCancelReason")
    remaining_quantity_e9: StrictStr = Field(description="The remaining quantity of the order.", alias="remainingQuantityE9")
    __properties: ClassVar[List[str]] = ["orderHash", "clientOrderId", "marketAddress", "accountAddress", "createdAtUtcMillis", "cancellationReason", "failureToCancelReason", "remainingQuantityE9"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of OrderCancellationUpdate from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of OrderCancellationUpdate from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "orderHash": obj.get("orderHash"),
            "clientOrderId": obj.get("clientOrderId"),
            "marketAddress": obj.get("marketAddress"),
            "accountAddress": obj.get("accountAddress"),
            "createdAtUtcMillis": obj.get("createdAtUtcMillis"),
            "cancellationReason": obj.get("cancellationReason"),
            "failureToCancelReason": obj.get("failureToCancelReason"),
            "remainingQuantityE9": obj.get("remainingQuantityE9")
        })
        return _obj


